package cz.moneta.test.regression.backoffice.exevido.web.mailroom;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.exevido.pages.NewOutgoingMessagePage;
import cz.moneta.test.dsl.util.credentials.Keys;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenario;
import cz.moneta.test.harness.support.auth.Credentials;
import cz.moneta.test.harness.support.auth.Key;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeAll;

import static cz.moneta.test.dsl.exevido.pages.NewOutgoingMessagePage.ATTACHMENT_PATH;
import static cz.moneta.test.dsl.util.task.ufo.cb.CommercialTasks.JIRA_COMMENT_STORE_KEY;

@TestScenario(name = "Message Between Mailboxes")
public class MessageBetweenMailboxes {

    private String receiver;

    @BeforeAll
    protected void setUp(Harness harness) {
        receiver = harness.getConfig("commercial.exevido.receiver");
    }

    @TestCase(name = "Message Between Mailboxes")
    @JiraTestCase(id = "BOC-T8560")
    public void messageBetweenMailboxes(Harness harness, @Key(Keys.exevido.mailroom) Credentials credentials) {
        harness.withExevido()
                .openLoginPage()
                .then(harness.tasks().exevidoTasks().login().withCredentialsToMmb(credentials))
                .clickOutgoingMessages()
                .clickAllOutgoingMessages()
                .clickCreateNewOutgoingMessage()
                .fillRecipient(receiver)
                .pressEnter()
                .uploadAttachment(ATTACHMENT_PATH)
                .fillSubject("Automat TEST")
                .fillAssigneeUserGroup("F00102")
                .clickSendMessageDropdown()
                .clickSendMessageNow()
                .checkMessageCorrectlySend()
                .storeMessageId();
    }

    @AfterEach
    protected void tearDown(Harness harness) {
        harness.store(JIRA_COMMENT_STORE_KEY,
                "\nMessage ID: " + harness.get(NewOutgoingMessagePage.MESSAGE_ID_KEY, true));
    }
}